module wall(col=[0.6,0.6,0.0])
{
   color(col)
   {
       cube([160,5,80],center=true);
       rotate([0,0,90])
       {
           translate([0,40,-42.5]){ cube([55,15,5], center=true); }
           translate([0,-40,-42.5]){ cube([55,15,5], center=true); }
       }
   }
}

module miniwall()
{ cube([160,5,5],center=true);
  rotate([0,0,90])
  {
      translate([0,40,-5]){ cube([55,15,5], center=true); }
      translate([0,-40,-5]){ cube([55,15,5], center=true); }
  }
}

module maze_cell(pose, sides)
{
    plate_color=[0.8,0.8,0.8];
    translate([0+pose[0]*165, 0+pose[1]*165,0])
    {   
        if ( pose[0] == 0 )
        {
            plate_color=[1,1,1];
        }

        // base plate    
        translate([0,0,5+2.5]){ color([0.5+0.25*( (abs(pose[0])+abs(pose[1])) % 2), 0.5+0.25*( (abs(pose[0])+abs(pose[1])) % 2), 0.5+0.25*( (abs(pose[0])+abs(pose[1])) % 2)]){ cube([160,160,5],center=true); } }

        for(s=sides)
        {
            translate([0,82.5,45])
            {
                color([1,1,0,0.4])
                if (s == "N") { wall(); }
                else if(s == "n"){ translate([0,0,-37.5]){ miniwall(); } }
            }
              
            translate([82.5,0,45]) rotate([0,0,90])
            {
                color([0,0,1,0.4])
                if (s == "E"){ wall(); }
                else if(s == "e"){ translate([0,0,-37.5]){ miniwall(); } }
            }
            
            translate([0,-82.5,45])
            { color([0,1,0,0.4])
              if (s == "S"){ wall(); }
              else if(s == "s"){ translate([0,0,-37.5]){ miniwall(); } }
            }
            
            translate([-82.5,0,45]) rotate([0,0,90]) 
            {
               color([1,0,0,0.4])
                if (s == "W"){ wall(); }
                else if(s == "w"){ translate([0,0,-37.5]){ miniwall(); } }
            }
       }
    }
}

translate([-200,0,0])
{
    l1=90;
    l2=60;
    w1=15;
    // N
    color([1,1,0,0.4]) { cube([w1,l1,5]); }
    // E
    rotate([0,0,-90])
    color([0,0,1,0.4]){ cube([w1,l2,5]); }
    // S
    rotate([0,0,-180])
    color([0,1,0,0.4]){ cube([w1,l2,5]); }
    //W
    rotate([0,0,-270])
    color([1,0,0,0.4]){ cube([w1,l2,5]); }
}

// Test Maze
maze_cell([0,0],["n","S","e","W"]);
maze_cell([0,1],["W","e","n"]);
maze_cell([1,0],["S","n","e"]);
maze_cell([1,1],["N","E"]);
maze_cell([0,2],["W","n","e"]);
maze_cell([1,2],["n","e"]);
maze_cell([2,2],["S","E","n"]);
maze_cell([2,0],["S","n","e"]);
maze_cell([2,1],["e"]);
maze_cell([0,3],["W","N","e"]);
maze_cell([1,3],["N","e"]);
maze_cell([2,3],["N","e"]);
maze_cell([3,3],["N","E"]);
maze_cell([3,0],["S","E","n"]);
maze_cell([3,1],["E","n"]);
maze_cell([3,2],["E","n"]);
